// GDL - Claudio Caete Cabeza 2.000
// Generador de Laberintos, V 2.0
#include <graphics.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "memoria.h"
#include "raton.h"

#define VGA 9
#define GMODE 2

laberinto lab;		// Estructura que almacena el laberinto
pila p;			// Pila que ayuda a generar y resolver el laberinto

// Genera el laberinto
int Genera(int sizex, int sizey,char ver);
// Pinta en pantalla el laberinto (modifica la variable ver)
void Pinta(int sizex, int sizey, char *ver);
// Carga de un fichero (con el formato de salvado) un laberinto
void Carga(int *sizex,int *sizey, char *resuelto);
// Guarda en un fichero (de texto) el laberinto actual
void Guarda(int sizex, int sizey);
// Resuelve el laberinto actual
void Resuelve(int sizex, int sizey);
// Pinta el menu y las lineas del interfaz grfico
void Menu(int sizex, int sizey, char ver);
// Escribe el mensaje de ayuda
void Ayuda(void);
// Coloca al programa en modo juego
void Juego(int sizex, int sizey);


// FUNCION PRINCIPAL
void main (void)
{
	int x=20,y=20; //Tamao del laberinto
	int driver=VGA, mode=GMODE;   //Variables para el modo de video
	char tecla; //tecla pulsada
	char ver=0; //Indica si esta activado el visionado de la creacion
		    //del laberinto
	char resuelto=0,generado=0; // indica si ha sido resuelto o
				    // generado el laberinto
	char estadoraton=0; //indica si hay driver de raton
	int posx,posy,botizq,botder; //variables para el control del raton

	//antes de nada, compruebo que exista memoria para un
	//laberinto inicial de 20x20.
	if (Inicializar_laberinto(x,y,&lab)==-1) {
		printf("Error, no se ha podido iniciar el programa\n");
		exit(0);
	}

	// Inicializo el modo de video y pinto la pantalla principal
	// Genero uno de 20x20 y lo pinto.
	initgraph(&driver,&mode,"");
	Menu(x,y,ver);
	Genera(x,y,ver);
	generado=1;
	Pinta(x,y,&ver);

	//compruebo si hay driver de raton
	if ((inicializaraton())==0) estadoraton=1;

	//BUCLE PRINCIPAL (termina con ESC)
	do {
		//si hay raton, actualizo sus variables
		if (estadoraton==1) {
			raton(&posx,&posy,&botizq,&botder);
		}

		//si se pulsa el boton izquierdo, actualizo tecla
		//segun la zona
		if (botizq!=0) {
			if ((posx>405) && (posx<640) && (posy>0) && (posy<10)) tecla=59;
			if ((posx>405) && (posx<640) && (posy>10) && (posy<20)) tecla=60;
			if ((posx>405) && (posx<640) && (posy>20) && (posy<30)) tecla=61;
			if ((posx>405) && (posx<640) && (posy>30) && (posy<40)) tecla=62;
			if ((posx>405) && (posx<640) && (posy>40) && (posy<50)) tecla=63;
			if ((posx>405) && (posx<640) && (posy>50) && (posy<60)) tecla=64;
			if ((posx>405) && (posx<640) && (posy>60) && (posy<70)) tecla=27;
			if ((posx>5) && (posx<140) && (posy>405) && (posy<415)) tecla='1';
			if ((posx>5) && (posx<140) && (posy>415) && (posy<425)) tecla='3';
			if ((posx>5) && (posx<140) && (posy>425) && (posy<435)) tecla='v';
		}

		//igual con el boton derecho
		if (botder!=0) {
			if ((posx>5) && (posx<140) && (posy>405) && (posy<415)) tecla='2';
			if ((posx>5) && (posx<140) && (posy>415) && (posy<425)) tecla='4';
		}

		//si se ha pulsado una tecla, actualizo tecla
		if (kbhit()) {
			tecla=getch();
		}

		//segun la tecla pulsada (tecla)...
		switch (tecla) {
		 case 59: Ayuda();Menu(x,y,ver);Pinta(x,y,&ver);tecla=0;break;
		 case 60: if (Genera(x,y,ver)==0) { resuelto=0; if(!ver) {Pinta(x,y,&ver);} generado=1;} tecla=0;break;
		 case 61: if ((resuelto==0)&&(generado==1)) {Resuelve(x,y); resuelto=1;tecla=0;} else {tecla=60;} break;
		 case 62: if (generado==1) {Guarda(x,y);Menu(x,y,ver);Pinta(x,y,&ver);tecla=0;} else {tecla=60;} break;
		 case 63: Carga(&x,&y,&resuelto);Menu(x,y,ver);Pinta(x,y,&ver);tecla=0;break;
		 case 64: if (generado==1) {Juego(x,y);Menu(x,y,ver);Pinta(x,y,&ver);tecla=0;} else {tecla=60;} break;
		 case '1': x+=2;Menu(x,y,ver);generado=0;tecla=0;break;
		 case '2': x-=2;if (x<10) x=10;Menu(x,y,ver);generado=0;tecla=0;break;
		 case '3': y+=2;Menu(x,y,ver);generado=0;tecla=0;break;
		 case '4': y-=2;if (y<10) y=10;Menu(x,y,ver);generado=0;tecla=0;break;
		 case 'V': ver=!ver;Menu(x,y,ver);tecla=0;break;
		 case 'v': ver=!ver;Menu(x,y,ver);tecla=0;break;
		 case 27: break;
		 default: tecla=0;break;
		}

	} while (tecla!=27);


	//Restauro el modo de video
	Destruir_laberinto(&lab);
	restorecrtmode();
}


//Funcion que pinta el menu en pantalla y el interfaz grafico
void Menu(int sizex, int sizey, char ver)
{
	char temp[10], temp2[10]; //estos dos arrays se usan para imprimir
				  //sizex y sizey en modo grafico

	setcolor(LIGHTBLUE);
	line(0,0,639,0);
	line(0,400,639,400);
	line(0,0,0,480);
	line(639,0,639,480);
	line(0,479,639,479);
	line(400,0,400,400);

	setcolor(WHITE);
	outtextxy(405,5,"F1 - Ayuda");
	outtextxy(405,15,"F2 - Genera Laberinto");
	outtextxy(405,25,"F3 - Resuelve Laberinto");
	outtextxy(405,35,"F4 - Guarda Laberinto");
	outtextxy(405,45,"F5 - Carga Laberinto");
	outtextxy(405,55,"F6 - Juego");
	outtextxy(405,65,"ESC - Salir");
	outtextxy(5,469,"Status - OK!");

	setcolor(WHITE);
	outtextxy(5,405,"Tamao X (1+,2-):");
	outtextxy(5,415,"Tamao Y (3+,4-):");
	outtextxy(5,425,"Ver como se genera (V): ");

	setcolor(BLACK);
	outtextxy(195,425,"");

	setcolor(LIGHTRED);
	if (ver==0) outtextxy(195,425,"No");
	else outtextxy(195,425,"Si");

	itoa(sizex,temp,10);
	itoa(sizey,temp2,10);
	setcolor(BLACK);

	outtextxy(145,405,"");
	outtextxy(145,415,"");
	setcolor(LIGHTRED);
	outtextxy(145,405,temp);
	outtextxy(145,415,temp2);
	setcolor(LIGHTGRAY);
	outtextxy(370,469,"GDL - Claudio Caete 2.000 (Neco)");

	gotoxy(52,25);
	printf("                          ");
}

//Esta funcion genera el laberinto
int Genera(int sizex, int sizey, char ver) //Genera el laberinto
{
	int i,j,tempi,tempj;	//i y j, posicion actual
	int incx=(float)(400.0/sizex); //incremento en x (pixeles)
	int incy=(float)(400.0/sizey); //incremento en y (pixeles)
	int visitadas; //celdas visitadas
	int contador;  //celdas vecinas visitadas
	struct tipocelda elemento,elemnorte,elemsur,elemeste,elemoeste; //celda y celdas vecinas a la actual

	//Borro la pantalla
	for(i=1;i<400;i++)
		for(j=1;j<400;j++)
			putpixel(i,j,0);

	//en caso de que exista ya un laberinto, lo destruyo...
	Destruir_laberinto(&lab);

	//Inicializo el espacio para el laberinto
	if (Inicializar_laberinto(sizex,sizey,&lab)==-1)
	{
		setcolor(LIGHTRED);
		outtextxy(60,290,"No hay memoria suficiente para");
		outtextxy(100,310,"generar el laberinto");
		return -1; //si no hay memoria, retorna
	}

	// pinta el laberinto inicializado (cuadricula, todos los muros a 1)
	Pinta(sizex,sizey,&ver);

	//cambia el mensaje de estado
	setcolor(BLACK);
	outtextxy(5,469,"Status - ");
	setcolor(WHITE);
	outtextxy(5,469,"Status - Wait....");


	//Comienzo a generar el laberinto

	//Primero escoge una celda al azar, y pone visitadas a 1
	//marca la celda como visitada y comienza el bucle

	randomize();
	visitadas=1;
	i=random(sizex);
	j=random(sizey);
	elemento=Devuelve_elemento(i,j,lab,sizex,sizey);
	Modificar_elemento(i,j,sizex,sizey,&lab,elemento.s,elemento.e,1);

	//mientras que el numero de visitadas sea menor q tamao lab.

	while (visitadas<(sizex*sizey)) {
		elemnorte=Devuelve_elemento(i,j-1,lab,sizex,sizey);
		elemsur=Devuelve_elemento(i,j+1,lab,sizex,sizey);
		elemeste=Devuelve_elemento(i+1,j,lab,sizex,sizey);
		elemoeste=Devuelve_elemento(i-1,j,lab,sizex,sizey);

		if (j==0) elemnorte.visitada=1;
		if (j==(sizey-1)) elemsur.visitada=1;
		if (i==0) elemoeste.visitada=1;
		if (i==(sizex-1)) elemeste.visitada=1;

		contador=elemnorte.visitada+elemsur.visitada+
			 elemoeste.visitada+elemeste.visitada;

		//si todas las vecinas estan visitadas, saca de la pila

		if (contador==4) {
			Sacar(&i,&j,&p);
		}

		//si hay alguna sin visitar, entre las no visitadas
		//elige una

		else {
			do {
				tempi=i;
				tempj=j;
				switch(random(4)) {
				case 0: tempj--; if (tempj<0) tempj=0; break;
				case 1: tempj++; if (tempj>sizey-1) tempj=sizey-1; break;
				case 2: tempi++; if (tempi>sizex-1) tempi=sizex-1; break;
				case 3: tempi--; if (tempi<0) tempi=0; break;
				}
				elemento=Devuelve_elemento(tempi,tempj,lab,sizex,sizey);
			} while (elemento.visitada==1);

			//una vez elegida, mete en la pila la actual
			//quita el muro que las separa
			//incrementa visitadas
			//y pasa a ser la celda actual (visitada=1)


			if (Meter(i,j,&p)==-1) {
				//vaciar la pila
				while ((p->sig)!=NULL) {
					Sacar(&i,&j,&p);
				}
				Destruir_laberinto(&lab);
				return -1;
			}



			setcolor(BLACK);

			if (tempi>i) {//direccion este
				elemento=Devuelve_elemento(i,j,lab,sizex,sizey);
				elemento.e=0;
				Modificar_elemento(i,j,sizex,sizey,&lab,elemento.s,elemento.e,1);
				if (ver)
					line((i*incx)+incx,(j*incy)+1,(i*incx)+incx,((j*incy)+incy)-1);

			}
			if (tempi<i) {//direccion oeste
				elemento=Devuelve_elemento(tempi,j,lab,sizex,sizey);
				elemento.e=0;
				Modificar_elemento(tempi,j,sizex,sizey,&lab,elemento.s,elemento.e,1);
				if (ver)
					line((tempi*incx)+incx,(j*incy)+1,(tempi*incx)+incx,((j*incy)+incy)-1);

			}
			if (tempj>j) {//direccion sur
				elemento=Devuelve_elemento(i,j,lab,sizex,sizey);
				elemento.s=0;
				Modificar_elemento(i,j,sizex,sizey,&lab,elemento.s,elemento.e,1);
				if (ver)
					line((i*incx+1),(j*incy)+incy,((i*incx)+incx-1),(j*incy)+incy);

			}
			if (tempj<j) {//direccion norte
				elemento=Devuelve_elemento(i,tempj,lab,sizex,sizey);
				elemento.s=0;
				Modificar_elemento(i,tempj,sizex,sizey,&lab,elemento.s,elemento.e,1);
				if (ver)
					line((i*incx+1),(tempj*incy)+incy,((i*incx)+incx-1),(tempj*incy)+incy);
			}

			i=tempi;
			j=tempj;
			elemento=Devuelve_elemento(i,j,lab,sizex,sizey);
			Modificar_elemento(i,j,sizex,sizey,&lab,elemento.s,elemento.e,1);
			visitadas++;
			gotoxy(52,25);
			printf("Celdas:         ");
			gotoxy(52,25);
			printf("Celdas: %i",visitadas);

		}

	}
	//vaciar la pila
	while ((p->sig)!=NULL) {
	Sacar(&i,&j,&p);
	}

	//por ultimo, dejo el estado como estaba
	setcolor(BLACK);
	outtextxy(5,469,"Status - ");
	setcolor(WHITE);
	outtextxy(5,469,"Status - Ok!!!");

	return 0;
}

//Pinta el laberinto
void Pinta(int sizex, int sizey, char *ver)
{
	int incx,incy;
	int i,j;
	struct tipocelda elemento;

	//cambia el mensaje de estado
	setcolor(BLACK);
	outtextxy(5,469,"Status - ");
	setcolor(WHITE);
	outtextxy(5,469,"Status - Wait....");

	//si el laberinto es muy grande, no se puede pintar
	if ((sizex>100)||(sizey>100)) {
		setcolor(LIGHTRED);
		outtextxy(60,190,"El laberinto es demasiado grande");
		outtextxy(80,210,"para mostrarlo en pantalla");
		*ver=0;
		Menu(sizex,sizey,*ver);

	}
	else {
		incx=(float)(400.0/sizex);
		incy=(float)(400.0/sizey);


		//recorre el laberinto, si hay muro pinta una linea azul
		//y si no lo hay, una negra
		setcolor(LIGHTBLUE);
		for (i=0;i<sizex;i++)
			for (j=0;j<sizey;j++)
			{
				elemento=Devuelve_elemento(i,j,lab,sizex,sizey);
				if (elemento.s==1) {
					setcolor(LIGHTBLUE);
					line((i*incx),(j*incy)+incy,((i*incx)+incx),(j*incy)+incy);
				}
				else {
					setcolor(BLACK);
					line((i*incx)+1,(j*incy)+incy,((i*incx)+incx)-1,(j*incy)+incy);
				}
				if (elemento.e==1) {
					setcolor (LIGHTBLUE);
					line((i*incx)+incx,(j*incy),(i*incx)+incx,((j*incy)+incy));
				}
				else {
					setcolor(BLACK);
					line((i*incx)+incx,(j*incy)+1,(i*incx)+incx,((j*incy)+incy)-1);
				}
				if (elemento.visitada==2)
					putpixel((i*incx)+(incx/2),(j*incy)+(incy/2),WHITE);
			}

		//por ultimo, pinta la entrada y la salida y los bordes
		setcolor(LIGHTBLUE);
		line(0,sizey*incy,sizex*incx,sizey*incy);
		line(sizex*incx,0,sizex*incx,sizey*incy);
		setcolor(BLACK);
		line(1,0,incx-1,0);
		line(sizex*incx,(sizey*incy)-incy+1,sizex*incx,(sizey*incy)-1);

	}

	//restauro el mensaje de estado
	setcolor(BLACK);
	outtextxy(5,469,"Status - ");
	setcolor(WHITE);
	outtextxy(5,469,"Status - Ok!");
}

// Escribe la pantalla de ayuda.
void Ayuda() {
 cleardevice();
 gotoxy(1,1);
 printf("                                     AYUDA         \n");
 printf("--------------------------------------------------------------------------------\n");
 printf("\tEste programa es capaz de generar laberintos de cualquier tamao\n");
 printf("siempre que exista memoria disponible.\n");
 printf("\n");
 printf("\tReferencia de teclas:\n\n");
 printf("F1 -> Ayuda (esta pantalla).\n");
 printf("F2 -> Genera un laberinto en el tamao especificado.\n");
 printf("F3 -> Resuelve el laberinto que hay en pantalla. Atencin,\n");
 printf("      si existe un laberinto en pantalla generado, pero se \n");
 printf("      cambia el valor de x e y, generar uno nuevo.\n");
 printf("F4 -> Guarda el laberinto actual en un fichero (ocurre lo mismo\n");
 printf("      que en el caso anterior.\n");
 printf("F5 -> Carga un laberinto de un fichero previamente guardado con F4.\n");
 printf("F6 -> Modo juego, permite que el usuario con el teclado intente\n");
 printf("      resolver el laberinto. Termina cuando se pulsa ESC o se llega\n");
 printf("      a la salida.\n");
 printf("ESC -> Termina el programa\n");
 printf("1  -> Incrementa en 2 el valor de x.\n");
 printf("2  -> Decrementa en 2 el valor de x.\n");
 printf("3  -> Incrementa en 2 el valor de y.\n");
 printf("4  -> Decrementa en 2 el valor de y.\n");
 printf("v  -> Activa o desactiva la visualizacin de la generacin del laberinto.\n");
 printf("\n\n");
 printf("Pulsa una tecla para continuar con el programa.");
 getch();
 cleardevice();


}

// Guarda el laberinto actual en un fichero
void Guarda(int sizex, int sizey) {
	FILE *fich;   //Variable para direccionar el fichero
	char cadena[20]; //Nombre del fichero
	int i,j;
	struct tipocelda elemento;

	//primero pregunta el nombre del fichero
	cleardevice();
	gotoxy(1,1);
	printf("Nombre del fichero: ");
	gotoxy(22,27);
	gets(cadena);

	//si no se puede crear el fichero, termina
	if ((fich=fopen(cadena,"w"))==NULL) {
		printf("Error al crear el fichero\n");
	}
	else {
		printf("La cabecera del fichero es TAMAOX TAMAOY\n\n");
		printf("En cada fila hay:\n");
		printf("X Y \t PAREDSUR PAREDESTE VISITADA\n");
		printf("\n");
		printf("Las celdas con Visitada=2, son el camino solucin.\n");
		fprintf(fich,"%i %i\n",sizex,sizey);

		for (i=0;i<sizex;i++)
			for(j=0;j<sizey;j++) {
				elemento=Devuelve_elemento(i,j,lab,sizex,sizey);
				fprintf(fich,"%i %i   %i %i %i\n",i,j,elemento.s,elemento.e,elemento.visitada);
			}

		fclose(fich);
	}

	gotoxy(1,25);
	printf("Pulsa una tecla para continuar con el programa.");
	getch();
	cleardevice();

}

//Carga el laberinto (modifica la estrucura) de un fichero
void Carga(int *sizex,int *sizey,char *resuelto) {
	FILE *fich;   //Variable para direccionar el fichero
	char cadena[20]; //Nombre del fichero
	int i,j,s,e,visitada,x,y,tempx,tempy;

	//pregunta el nombre del fichero
	cleardevice();
	gotoxy(1,1);
	printf("Nombre del fichero: ");
	gotoxy(22,27);
	gets(cadena);

	//si el nombre no es vlido, termina
	if ((fich=fopen(cadena,"r"))==NULL) {
		printf("Error al abrir el fichero\n");
	} else
	{
		//en primer lugar, destruye el anterior
		Destruir_laberinto(&lab);
		//escanea la cabecera para ver el tamao
		fscanf(fich,"%i %i",&x,&y);
		*sizex=x;
		*sizey=y;
		//inicializa una nueva estructura, con el tamao nuevo
		if ((Inicializar_laberinto(x,y,&lab))==-1)
		{
			printf("No hay memoria suficiente para\n");
			printf("generar el laberinto\n");
		} else
		{

		//recorre a la vez la estructura y el fichero,
		//actualizando los datos
		for (i=0;i<x;i++)
			for (j=0;j<y;j++)
				{
				fscanf(fich,"%i %i   %i %i %i",&tempx,&tempy,&s,&e,&visitada);
				Modificar_elemento(i,j,*sizex,*sizey,&lab,s,e,visitada);
				if ((visitada==2)&&(resuelto==0)) *resuelto=1;
				}

		}
		fclose(fich);
	}


	//mensaje y espera por una tecla
	gotoxy(1,25);
	printf("Pulsa una tecla para continuar con el programa.");
	getch();
	cleardevice();

}


//resuelve el laberinto (busca la salida)
void Resuelve(int sizex, int sizey) {

 int i=0,j=0,tempi,tempj,temp;
 int incx,incy;
 int libres=1,libresur=0,libreeste=0,librenorte=0,libreoeste=0;
 struct tipocelda elemento,elementosur,elementoeste,elementooeste,elementonorte;

 incx=400/sizex;
 incy=400/sizey;

 //cambia el mensaje de estado
 setcolor(BLACK);
 outtextxy(5,469,"Status - ");
 setcolor(WHITE);
 outtextxy(5,469,"Status - Wait....");


 //mientras que i y j no llegen a la salida...
 //BUCLE PRINCIPAL
 while (( (i!=(sizex-1)) || (j!=(sizey-1))) ) {

	//si la celda actual esta a 1, pone un punto blanco
	elemento=Devuelve_elemento(i,j,lab,sizex,sizey);
	if (elemento.visitada==1) {
		putpixel((i*incx)+(incx/2),(j*incy)+(incy/2),WHITE);
	}

	//ahora miro cuales de las cuatro vecinas estan libres
	//(no han sido visitadas y son accesibles)
	libreeste=libreoeste=librenorte=libresur=0;

	if (i!=(sizex-1)) {
		elementoeste=Devuelve_elemento(i+1,j,lab,sizex,sizey);
		if ((elementoeste.visitada==1)&&(elemento.e==0)) { libreeste=1; }
	}
	if (j!=(sizey-1)) {
		elementosur=Devuelve_elemento(i,j+1,lab,sizex,sizey);
		if ((elementosur.visitada==1)&&(elemento.s==0)) { libresur=1; }
	}
	if (j!=0) {
		elementonorte=Devuelve_elemento(i,j-1,lab,sizex,sizey);
		if ((elementonorte.visitada==1)&&(elementonorte.s==0)) { librenorte=1; }
	}
	if (i!=0) {
		elementooeste=Devuelve_elemento(i-1,j,lab,sizex,sizey);
		if ((elementooeste.visitada==1)&&(elementooeste.e==0)) { libreoeste=1; }
	}
	libres=libreeste+libreoeste+libresur+librenorte;

	//si no hay libres,marco la celda actual con 9, y saco de la pila
	//una posicin anterior
	//ademas, pongo un punto negro (este camino no es valido)
	if (libres==0) {
		elemento=Devuelve_elemento(i,j,lab,sizex,sizey);
		Modificar_elemento(i,j,sizex,sizey,&lab,elemento.s,elemento.e,9);
		putpixel((i*incx)+(incx/2),(j*incy)+(incy/2),BLACK);
		Sacar(&i,&j,&p);


	//si hay alguna libre, meto en la pila la actual y me
	//muevo a alguna de las libres (marcando la actual)
	} else {
		elemento=Devuelve_elemento(i,j,lab,sizex,sizey);
		Meter(i,j,&p);
		Modificar_elemento(i,j,sizex,sizey,&lab,elemento.s,elemento.e,2);
		if (libresur) {  tempi=0; tempj=1; }
		if (libreeste) {  tempi=1; tempj=0; }
		if (librenorte) {  tempi=0; tempj=-1; }
		if (libreoeste) {  tempi=-1; tempj=0; }

		 i=i+tempi;
		 j=j+tempj;

	}
 }

 //por ultimo, pongo un punto en la ultima celda
 putpixel((i*incx)+(incx/2),(j*incy)+(incy/2),WHITE);

 //vaciar la pila
 while ((p->sig)!=NULL) {
	Sacar(&i,&j,&p);
 }

 //cambio el mensaje de estado
 setcolor(BLACK);
 outtextxy(5,469,"Status - ");
 setcolor(WHITE);
 outtextxy(5,469,"Status - Ok!");


}

//modo juego
void Juego(int sizex, int sizey) {
 int x,y;
 int incx,incy;
 char tecla;
 char fin=0;
 struct tipocelda elemento;

 incx=400/sizex;
 incy=400/sizey;


 //cambio el mensaje de estado
 setcolor(BLACK);
 outtextxy(5,469,"Status - ");
 setcolor(WHITE);
 outtextxy(5,459,"Para jugar, usa el teclado numrico (2,4,6 y 8)");
 outtextxy(5,469,"Status - Playing....<ESC> stop!");

 //posicion inicial, (0,0)
 x=0;
 y=0;

 //mientras que fin sea 0, bucle principal
 //fin se pone a 1 con ESC o terminando el juego
 do {
	//pinto el punto amarillo en la posicin actual
	 setcolor(YELLOW);
	 setfillstyle(SOLID_FILL,YELLOW);
	 fillellipse((x*incx)+(incx/2),(y*incy)+(incy/2),incx/10,incy/10);

	//espero a que se pulse una tecla
	tecla=getch();

	//borro el punto
	 setcolor(BLACK);
	 setfillstyle(SOLID_FILL,BLACK);
	 fillellipse((x*incx)+(incx/2),(y*incy)+(incy/2),incx/10,incy/10);

	 //segun que tecla se pulse, se mueve (si es posible)
	switch (tecla) {
	 case '8':
		elemento=Devuelve_elemento(x,y-1,lab,sizex,sizey);
		if (elemento.s==0) {
			y--;
			if (y<0) y=0;
		}
		tecla=0; break;
	 case '2':
		elemento=Devuelve_elemento(x,y,lab,sizex,sizey);
		if (elemento.s==0) {
			 y++;
			 if (y>(sizey-1)) y=sizey-1;
		}
		tecla=0; break;
	 case '4':
		elemento=Devuelve_elemento(x-1,y,lab,sizex,sizey);
		if (elemento.e==0) {
			 x--;
			 if (x<0) x=0;
		}
		tecla=0; break;
	 case '6':
		elemento=Devuelve_elemento(x,y,lab,sizex,sizey);
		if (elemento.e==0) {
			 x++;
			 if (x>(sizex-1)) x=sizex-1;
		}
		tecla=0; break;
	 case 27: fin=1; break;
	 default: tecla=0;break;
	}

	//si se llega a la celda de salida, fin=1
	if ((x==(sizex-1))&&(y==(sizey-1))) fin=1;


 } while (fin==0);

 //borro el punto
 setcolor(BLACK);
 setfillstyle(SOLID_FILL,BLACK);
 fillellipse((x*incx)+(incx/2),(y*incy)+(incy/2),incx/10,incy/10);


 //restauro el mensaje de estado
 setcolor(BLACK);
 outtextxy(5,469,"Status - ");
 setcolor(WHITE);
 outtextxy(5,469,"Status - Ok!");

}




