#include "memoria.h"
#include <stdio.h>

// esta funcin inicializa una matriz dinamica en forma de lista
// con el tamao i*j, en caso de que se quede sin memoria,
// devuelve -1 y libera todo lo que se haya reservado hasta
// el momento.
int Inicializar_laberinto(int i,int j,laberinto *lab)
{
	laberinto nuevo,temp;
	int x,y;
	if ((nuevo=(laberinto) malloc(sizeof(struct tipocelda)))==NULL)
		return -1;

	*lab=nuevo;
	for(x=0;x<i;x++) {
		for (y=0;y<j;y++)
			{
			nuevo->s=1;
			nuevo->e=1;
			nuevo->visitada=0;
			if ((nuevo->sig=(laberinto) malloc(sizeof(struct tipocelda)))==NULL)
			{
				Destruir_laberinto(lab);
				return -1;
			}
			temp=nuevo;
			nuevo=nuevo->sig;
			}
	}
	temp->sig=NULL;
	return 0;
}

//esta funcin destruye la matriz dinamica, liberando la memoria
void Destruir_laberinto(laberinto *lab)
{
 laberinto p=*lab;

 while (*lab) {
	 (*lab)=(*lab)->sig;
	 if (p!=NULL) free(p);
	 p=*lab;
 }

}

//esta funcion devuelve un elemento de la estructura dinamica
//sin modificarla.
struct tipocelda Devuelve_elemento(int i,int j,laberinto lab,int sizex, int sizey)
{
	int x,y;
	laberinto p=lab;

	if (i<0) i=0;
	if (i>(sizex-1)) i=sizex-1;
	if (j<0) j=0;
	if (j>(sizey-1)) j=sizey-1;

	for(x=0;x<((j*sizex)+i);x++) {
		 p=p->sig;
	}

	return *p;
}

//esta funcion modifica un elemento de la estructura dinamica
//los parametros del elemento se pasan como variables
int Modificar_elemento(int i,int j, int sizex, int sizey, laberinto *lab, int s, int e, int visitada)
{
	int x,y;
	laberinto p=*lab;

	if (i<0) i=0;
	if (i>(sizex-1)) i=sizex-1;
	if (j<0) j=0;
	if (j>(sizey-1)) j=sizey-1;


	for(x=0;x<((j*sizex)+i);x++) {
		 p=p->sig;
	}

	(*p).s=s;
	(*p).e=e;
	(*p).visitada=visitada;
	return 0;



}

//esta funcion aade un elemento a la pila dinamica
//si no hay memoria, devuelve -1 (imprime un mensaje) y deja la pila
//como estaba. Si todo va bien devuelve 0.
int Meter(int i,int j, pila *p) {
	pila temp=*p;

	if (*p==NULL) {
		if ((*p=(pila) malloc(sizeof(struct tipopila)))==NULL) {
			printf("  No hay memoria");
			return -1;
		}
		(*p)->i=i;
		(*p)->j=j;
		(*p)->sig=NULL;
		return 0;
	}

	while (temp->sig!=NULL) {
		temp=temp->sig;
	}
	if ((temp->sig=(pila) malloc(sizeof(struct tipopila)))==NULL) {
		printf("No hay memoria");
		return -1;
	}
	temp=temp->sig;
	temp->i=i;
	temp->j=j;
	temp->sig=NULL;
	return 0;
}

//Esta funcion saca de la pila un elemento,
//liberando la memoria que ocupaba y modificando la pila.
int Sacar(int *i, int *j, pila *p) {
	pila temp=*p;
	pila temp2=temp;

	while (temp->sig!=NULL) {
		temp2=temp;
		temp=temp->sig;
	}
	*i=temp->i;
	*j=temp->j;
	free(temp2->sig);
	temp2->sig=NULL;
	return 0;
}
